VTK: vtkLineWidget Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Types | Protected Member Functions | Static Protected Member Functions | Protected Attributes | Friends | List of all members
vtkLineWidget Class Reference

3D widget for manipulating a line More...

`#include <vtkLineWidget.h>`

Inheritance diagram for vtkLineWidget:
[legend]
Collaboration diagram for vtkLineWidget:
[legend]

## Public Types
typedef vtk3DWidget | Superclass
Public Types inherited from vtk3DWidget
typedef vtkInteractorObserver | Superclass
Public Types inherited from vtkInteractorObserver
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkLineWidget * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | SetResolution (int r)
| Set/Get the resolution (number of subdivisions) of the line. More...
int | GetResolution ()
void | SetPoint1 (double x, double y, double z)
| Set/Get the position of first end point. More...
void | SetPoint1 (double x[3])
double * | GetPoint1 ()
void | GetPoint1 (double xyz[3])
void | SetPoint2 (double x, double y, double z)
| Set position of other end point. More...
void | SetPoint2 (double x[3])
double * | GetPoint2 ()
void | GetPoint2 (double xyz[3])
void | GetPolyData (vtkPolyData *pd)
| Grab the polydata (including points) that defines the line. More...
void | SetEnabled (int) override
| Methods that satisfy the superclass' API. More...
void | PlaceWidget (double bounds[6]) override
| Methods that satisfy the superclass' API. More...
void | PlaceWidget () override
| Methods that satisfy the superclass' API. More...
void | PlaceWidget (double xmin, double xmax, double ymin, double ymax, double zmin, double zmax) override
| Methods that satisfy the superclass' API. More...
virtual void | SetAlign (int)
| Force the line widget to be aligned with one of the x-y-z axes. More...
virtual int | GetAlign ()
| Force the line widget to be aligned with one of the x-y-z axes. More...
void | SetAlignToXAxis ()
| Force the line widget to be aligned with one of the x-y-z axes. More...
void | SetAlignToYAxis ()
| Force the line widget to be aligned with one of the x-y-z axes. More...
void | SetAlignToZAxis ()
| Force the line widget to be aligned with one of the x-y-z axes. More...
void | SetAlignToNone ()
| Force the line widget to be aligned with one of the x-y-z axes. More...
virtual void | SetClampToBounds (vtkTypeBool)
| Enable/disable clamping of the point end points to the bounding box of the data. More...
virtual vtkTypeBool | GetClampToBounds ()
| Enable/disable clamping of the point end points to the bounding box of the data. More...
virtual void | ClampToBoundsOn ()
| Enable/disable clamping of the point end points to the bounding box of the data. More...
virtual void | ClampToBoundsOff ()
| Enable/disable clamping of the point end points to the bounding box of the data. More...
virtual vtkProperty * | GetHandleProperty ()
| Get the handle properties (the little balls are the handles). More...
virtual vtkProperty * | GetSelectedHandleProperty ()
| Get the handle properties (the little balls are the handles). More...
virtual vtkProperty * | GetLineProperty ()
| Get the line properties. More...
virtual vtkProperty * | GetSelectedLineProperty ()
| Get the line properties. More...
Public Member Functions inherited from vtk3DWidget
vtk3DWidget * | NewInstance () const
virtual void | SetProp3D (vtkProp3D *)
| Specify a vtkProp3D around which to place the widget. More...
virtual vtkProp3D * | GetProp3D ()
| Specify a vtkProp3D around which to place the widget. More...
virtual void | SetInputData (vtkDataSet *)
| Specify the input dataset. More...
virtual void | SetInputConnection (vtkAlgorithmOutput *)
| Specify the input dataset. More...
virtual vtkDataSet * | GetInput ()
| Specify the input dataset. More...
virtual void | SetPlaceFactor (double)
| Set/Get a factor representing the scaling of the widget upon placement (via the PlaceWidget() method). More...
virtual double | GetPlaceFactor ()
| Set/Get a factor representing the scaling of the widget upon placement (via the PlaceWidget() method). More...
virtual void | SetHandleSize (double)
| Set/Get the factor that controls the size of the handles that appear as part of the widget. More...
virtual double | GetHandleSize ()
| Set/Get the factor that controls the size of the handles that appear as part of the widget. More...
Public Member Functions inherited from vtkInteractorObserver
vtkInteractorObserver * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
int | GetEnabled ()
void | EnabledOn ()
void | EnabledOff ()
void | On ()
void | Off ()
virtual void | OnChar ()
| Sets up the keypress-i event. More...
virtual void | SetInteractor (vtkRenderWindowInteractor *iren)
| This method is used to associate the widget with the render window interactor. More...
virtual vtkRenderWindowInteractor * | GetInteractor ()
| This method is used to associate the widget with the render window interactor. More...
virtual void | SetPriority (float)
| Set/Get the priority at which events are processed. More...
virtual float | GetPriority ()
| Set/Get the priority at which events are processed. More...
virtual void | PickingManagedOn ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | PickingManagedOff ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | SetPickingManaged (bool managed)
| Enable/Disable the use of a manager to process the picking. More...
virtual bool | GetPickingManaged ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | SetKeyPressActivation (vtkTypeBool)
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual vtkTypeBool | GetKeyPressActivation ()
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual void | KeyPressActivationOn ()
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual void | KeyPressActivationOff ()
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual void | SetKeyPressActivationValue (char)
| Specify which key press value to use to activate the interactor observer (if key press activation is enabled). More...
virtual char | GetKeyPressActivationValue ()
| Specify which key press value to use to activate the interactor observer (if key press activation is enabled). More...
virtual vtkRenderer * | GetDefaultRenderer ()
| Set/Get the default renderer to use when activating the interactor observer. More...
virtual void | SetDefaultRenderer (vtkRenderer *)
| Set/Get the default renderer to use when activating the interactor observer. More...
virtual vtkRenderer * | GetCurrentRenderer ()
| Set/Get the current renderer. More...
virtual void | SetCurrentRenderer (vtkRenderer *)
| Set/Get the current renderer. More...
void | GrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods enable an interactor observer to exclusively grab all events invoked by its associated vtkRenderWindowInteractor. More...
void | ReleaseFocus ()
| These methods enable an interactor observer to exclusively grab all events invoked by its associated vtkRenderWindowInteractor. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkLineWidget * | New ()
| Instantiate the object. More...
static vtkTypeBool | IsTypeOf (const char *type)
static vtkLineWidget * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtk3DWidget
static vtkTypeBool | IsTypeOf (const char *type)
static vtk3DWidget * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkInteractorObserver
static vtkTypeBool | IsTypeOf (const char *type)
static vtkInteractorObserver * | SafeDownCast (vtkObjectBase *o)
static void | ComputeDisplayToWorld (vtkRenderer *ren, double x, double y, double z, double worldPt[4])
| Convenience methods for outside classes. More...
static void | ComputeWorldToDisplay (vtkRenderer *ren, double x, double y, double z, double displayPt[3])
| Convenience methods for outside classes. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Types
enum | WidgetState { Start = 0 , MovingHandle , MovingLine , Scaling , Outside }
enum | AlignmentState { XAxis , YAxis , ZAxis , None }

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkLineWidget ()
| ~vtkLineWidget () override
void | OnLeftButtonDown ()
void | OnLeftButtonUp ()
void | OnMiddleButtonDown ()
void | OnMiddleButtonUp ()
void | OnRightButtonDown ()
void | OnRightButtonUp ()
virtual void | OnMouseMove ()
void | HighlightLine (int highlight)
void | BuildRepresentation ()
void | SizeHandles () override
void | HandlesOn (double length)
void | HandlesOff ()
int | HighlightHandle (vtkProp *prop)
void | HighlightHandles (int highlight)
void | SetLinePosition (double x[3])
void | RegisterPickers () override
| Register internal Pickers in the Picking Manager. More...
void | Scale (double *p1, double *p2, int X, int Y)
void | ClampPosition (double x[3])
int | InBounds (double x[3])
void | CreateDefaultProperties ()
void | GenerateLine ()
void | EnablePointWidget ()
void | DisablePointWidget ()
int | ForwardEvent (unsigned long event)
Protected Member Functions inherited from vtk3DWidget
| vtk3DWidget ()
| ~vtk3DWidget () override
void | AdjustBounds (double bounds[6], double newBounds[6], double center[3])
double | SizeHandles (double factor)
void | UpdateInput ()
Protected Member Functions inherited from vtkInteractorObserver
| vtkInteractorObserver ()
| ~vtkInteractorObserver () override
void | UnRegisterPickers ()
| Unregister internal pickers from the Picking Manager. More...
vtkPickingManager * | GetPickingManager ()
| Return the picking manager associated on the context on which the observer currently belong. More...
vtkAssemblyPath * | GetAssemblyPath (double X, double Y, double Z, vtkAbstractPropPicker *picker)
| Proceed to a pick, whether through the PickingManager if the picking is managed or directly using the picker, and return the assembly path. More...
int | RequestCursorShape (int requestedShape)
virtual void | StartInteraction ()
| Utility routines used to start and end interaction. More...
virtual void | EndInteraction ()
| Utility routines used to start and end interaction. More...
void | ComputeDisplayToWorld (double x, double y, double z, double worldPt[4])
| Helper method for subclasses. More...
void | ComputeWorldToDisplay (double x, double y, double z, double displayPt[3])
| Helper method for subclasses. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Static Protected Member Functions
static void | ProcessEvents (vtkObject *object, unsigned long event, void *clientdata, void *calldata)
Static Protected Member Functions inherited from vtkInteractorObserver
static void | ProcessEvents (vtkObject *object, unsigned long event, void *clientdata, void *calldata)
| Handles the char widget activation event. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Protected Attributes
int | State
int | Align
vtkActor * | LineActor
vtkPolyDataMapper * | LineMapper
vtkLineSource * | LineSource
vtkActor ** | Handle
vtkPolyDataMapper ** | HandleMapper
vtkSphereSource ** | HandleGeometry
vtkCellPicker * | HandlePicker
vtkCellPicker * | LinePicker
vtkActor * | CurrentHandle
double | LastPosition [3]
vtkTypeBool | ClampToBounds
vtkProperty * | HandleProperty
vtkProperty * | SelectedHandleProperty
vtkProperty * | LineProperty
vtkProperty * | SelectedLineProperty
vtkPointWidget * | PointWidget
vtkPointWidget * | PointWidget1
vtkPointWidget * | PointWidget2
vtkPWCallback * | PWCallback
vtkPW1Callback * | PW1Callback
vtkPW2Callback * | PW2Callback
vtkPointWidget * | CurrentPointWidget
Protected Attributes inherited from vtk3DWidget
vtkProp3D * | Prop3D
vtk3DWidgetConnection * | ConnectionHolder
double | PlaceFactor
int | Placed
double | InitialBounds [6]
double | InitialLength
double | HandleSize
int | ValidPick
double | LastPickPosition [3]
Protected Attributes inherited from vtkInteractorObserver
int | Enabled
vtkCallbackCommand * | EventCallbackCommand
vtkCallbackCommand * | KeyPressCallbackCommand
float | Priority
bool | PickingManaged
vtkTypeBool | KeyPressActivation
char | KeyPressActivationValue
vtkRenderWindowInteractor * | Interactor
vtkRenderer * | CurrentRenderer
vtkRenderer * | DefaultRenderer
unsigned long | CharObserverTag
unsigned long | DeleteObserverTag
vtkObserverMediator * | ObserverMediator
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Friends
class | vtkPWCallback

## Detailed Description

3D widget for manipulating a line

This 3D widget defines a line that can be interactively placed in a scene. The line has two handles (at its endpoints), plus the line can be picked to translate it in the scene. A nice feature of the object is that the vtkLineWidget, like any 3D widget, will work with the current interactor style and any other widgets present in the scene. That is, if vtkLineWidget does not handle an event, then all other registered observers (including the interactor style) have an opportunity to process the event. Otherwise, the vtkLineWidget will terminate the processing of the event that it handles.

To use this object, just invoke SetInteractor() with the argument of the method a vtkRenderWindowInteractor. You may also wish to invoke "PlaceWidget()" to initially position the widget. The interactor will act normally until the "i" key (for "interactor") is pressed, at which point the vtkLineWidget will appear. (See superclass documentation for information about changing this behavior.) By grabbing one of the two end point handles (use the left mouse button), the line can be oriented and stretched (the other end point remains fixed). By grabbing the line itself, or using the middle mouse button, the entire line can be translated. Scaling (about the center of the line) is achieved by using the right mouse button. By moving the mouse "up" the render window the line will be made bigger; by moving "down" the render window the widget will be made smaller. Turn off the widget by pressing the "i" key again (or invoke the Off() method). (Note: picking the line or either one of the two end point handles causes a vtkPointWidget to appear. This widget has the ability to constrain motion to an axis by pressing the "shift" key while moving the mouse.)

The vtkLineWidget has several methods that can be used in conjunction with other VTK objects. The Set/GetResolution() methods control the number of subdivisions of the line; the GetPolyData() method can be used to get the polygonal representation and can be used for things like seeding streamlines. Typical usage of the widget is to make use of the StartInteractionEvent, InteractionEvent, and EndInteractionEvent events. The InteractionEvent is called on mouse motion; the other two events are called on button down and button up (either left or right button).

Some additional features of this class include the ability to control the properties of the widget. You can set the properties of the selected and unselected representations of the line. For example, you can set the property for the handles and line. In addition there are methods to constrain the line so that it is aligned along the x-y-z axes.

See also
  vtk3DWidget vtkBoxWidget vtkPlaneWidget

Events:
  vtkCommand::DisableEvent vtkCommand::EnableEvent vtkCommand::EndInteractionEvent vtkCommand::InteractionEvent vtkCommand::StartInteractionEvent

Online Examples:

Tests:
  vtkLineWidget (Tests)

Definition at line 91 of file vtkLineWidget.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtk3DWidget vtkLineWidget::Superclass

Definition at line 99 of file vtkLineWidget.h.

## Member Enumeration Documentation

## ◆ WidgetState

enum vtkLineWidget::WidgetState
| protected

Enumerator
Start |
MovingHandle |
MovingLine |
Scaling |
Outside |

Definition at line 201 of file vtkLineWidget.h.

## ◆ AlignmentState

enum vtkLineWidget::AlignmentState
| protected

Enumerator
XAxis |
YAxis |
ZAxis |
None |

Definition at line 226 of file vtkLineWidget.h.

## Constructor & Destructor Documentation

## ◆ vtkLineWidget()

vtkLineWidget::vtkLineWidget | ( |  | ) |
| protected

## ◆ ~vtkLineWidget()

vtkLineWidget::~vtkLineWidget | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkLineWidget* vtkLineWidget::New | ( |  | ) |
| static

Instantiate the object.

## ◆ IsTypeOf()

static vtkTypeBool vtkLineWidget::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkLineWidget::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtk3DWidget.

## ◆ SafeDownCast()

static vtkLineWidget* vtkLineWidget::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkLineWidget::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtk3DWidget.

## ◆ NewInstance()

vtkLineWidget* vtkLineWidget::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkLineWidget::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtk3DWidget.

## ◆ SetEnabled()

void vtkLineWidget::SetEnabled | ( | int |  | ) |
| overridevirtual

Methods that satisfy the superclass' API.

Reimplemented from vtkInteractorObserver.

## ◆ PlaceWidget() [1/3]

void vtkLineWidget::PlaceWidget | ( | double | bounds[6] | ) |
| overridevirtual

Methods that satisfy the superclass' API.

Implements vtk3DWidget.

## ◆ PlaceWidget() [2/3]

void vtkLineWidget::PlaceWidget | ( |  | ) |
| inlineoverridevirtual

Methods that satisfy the superclass' API.

Reimplemented from vtk3DWidget.

Definition at line 108 of file vtkLineWidget.h.

## ◆ PlaceWidget() [3/3]

void vtkLineWidget::PlaceWidget | ( | double | xmin,
|  | double | xmax,
|  | double | ymin,
|  | double | ymax,
|  | double | zmin,
|  | double | zmax
| ) |  |
| inlineoverridevirtual

Methods that satisfy the superclass' API.

Reimplemented from vtk3DWidget.

Definition at line 109 of file vtkLineWidget.h.

## ◆ SetResolution()

void vtkLineWidget::SetResolution | ( | int | r | ) |
| inline

Set/Get the resolution (number of subdivisions) of the line.

Definition at line 119 of file vtkLineWidget.h.

## ◆ GetResolution()

int vtkLineWidget::GetResolution | ( |  | ) |
| inline

Definition at line 120 of file vtkLineWidget.h.

## ◆ SetPoint1() [1/2]

void vtkLineWidget::SetPoint1 | ( | double | x,
|  | double | y,
|  | double | z
| ) |  |

Set/Get the position of first end point.

## ◆ SetPoint1() [2/2]

void vtkLineWidget::SetPoint1 | ( | double | x[3] | ) |
| inline

Definition at line 126 of file vtkLineWidget.h.

## ◆ GetPoint1() [1/2]

double* vtkLineWidget::GetPoint1 | ( |  | ) |
| inline

Definition at line 127 of file vtkLineWidget.h.

## ◆ GetPoint1() [2/2]

void vtkLineWidget::GetPoint1 | ( | double | xyz[3] | ) |
| inline

Definition at line 128 of file vtkLineWidget.h.

## ◆ SetPoint2() [1/2]

void vtkLineWidget::SetPoint2 | ( | double | x,
|  | double | y,
|  | double | z
| ) |  |

Set position of other end point.

## ◆ SetPoint2() [2/2]

void vtkLineWidget::SetPoint2 | ( | double | x[3] | ) |
| inline

Definition at line 134 of file vtkLineWidget.h.

## ◆ GetPoint2() [1/2]

double* vtkLineWidget::GetPoint2 | ( |  | ) |
| inline

Definition at line 135 of file vtkLineWidget.h.

## ◆ GetPoint2() [2/2]

void vtkLineWidget::GetPoint2 | ( | double | xyz[3] | ) |
| inline

Definition at line 136 of file vtkLineWidget.h.

## ◆ SetAlign()

virtual void vtkLineWidget::SetAlign | ( | int |  | ) |
| virtual

Force the line widget to be aligned with one of the x-y-z axes.

Remember that when the state changes, a ModifiedEvent is invoked. This can be used to snap the line to the axes if it is originally not aligned.

## ◆ GetAlign()

virtual int vtkLineWidget::GetAlign | ( |  | ) |
| virtual

Force the line widget to be aligned with one of the x-y-z axes.

Remember that when the state changes, a ModifiedEvent is invoked. This can be used to snap the line to the axes if it is originally not aligned.

## ◆ SetAlignToXAxis()

void vtkLineWidget::SetAlignToXAxis | ( |  | ) |
| inline

Force the line widget to be aligned with one of the x-y-z axes.

Remember that when the state changes, a ModifiedEvent is invoked. This can be used to snap the line to the axes if it is originally not aligned.

Definition at line 147 of file vtkLineWidget.h.

## ◆ SetAlignToYAxis()

void vtkLineWidget::SetAlignToYAxis | ( |  | ) |
| inline

Force the line widget to be aligned with one of the x-y-z axes.

Remember that when the state changes, a ModifiedEvent is invoked. This can be used to snap the line to the axes if it is originally not aligned.

Definition at line 148 of file vtkLineWidget.h.

## ◆ SetAlignToZAxis()

void vtkLineWidget::SetAlignToZAxis | ( |  | ) |
| inline

Force the line widget to be aligned with one of the x-y-z axes.

Remember that when the state changes, a ModifiedEvent is invoked. This can be used to snap the line to the axes if it is originally not aligned.

Definition at line 149 of file vtkLineWidget.h.

## ◆ SetAlignToNone()

void vtkLineWidget::SetAlignToNone | ( |  | ) |
| inline

Force the line widget to be aligned with one of the x-y-z axes.

Remember that when the state changes, a ModifiedEvent is invoked. This can be used to snap the line to the axes if it is originally not aligned.

Definition at line 150 of file vtkLineWidget.h.

## ◆ SetClampToBounds()

virtual void vtkLineWidget::SetClampToBounds | ( | vtkTypeBool |  | ) |
| virtual

Enable/disable clamping of the point end points to the bounding box of the data.

The bounding box is defined from the last PlaceWidget() invocation, and includes the effect of the PlaceFactor which is used to gram/shrink the bounding box.

## ◆ GetClampToBounds()

virtual vtkTypeBool vtkLineWidget::GetClampToBounds | ( |  | ) |
| virtual

Enable/disable clamping of the point end points to the bounding box of the data.

The bounding box is defined from the last PlaceWidget() invocation, and includes the effect of the PlaceFactor which is used to gram/shrink the bounding box.

## ◆ ClampToBoundsOn()

virtual void vtkLineWidget::ClampToBoundsOn | ( |  | ) |
| virtual

Enable/disable clamping of the point end points to the bounding box of the data.

The bounding box is defined from the last PlaceWidget() invocation, and includes the effect of the PlaceFactor which is used to gram/shrink the bounding box.

## ◆ ClampToBoundsOff()

virtual void vtkLineWidget::ClampToBoundsOff | ( |  | ) |
| virtual

Enable/disable clamping of the point end points to the bounding box of the data.

The bounding box is defined from the last PlaceWidget() invocation, and includes the effect of the PlaceFactor which is used to gram/shrink the bounding box.

## ◆ GetPolyData()

void vtkLineWidget::GetPolyData | ( | vtkPolyData * | pd | ) |

Grab the polydata (including points) that defines the line.

The polydata consists of n+1 points, where n is the resolution of the line. These point values are guaranteed to be up-to-date when either the InteractionEvent or EndInteraction events are invoked. The user provides the vtkPolyData and the points and polyline are added to it.

## ◆ GetHandleProperty()

virtual vtkProperty* vtkLineWidget::GetHandleProperty | ( |  | ) |
| virtual

Get the handle properties (the little balls are the handles).

The properties of the handles when selected and normal can be manipulated.

## ◆ GetSelectedHandleProperty()

virtual vtkProperty* vtkLineWidget::GetSelectedHandleProperty | ( |  | ) |
| virtual

Get the handle properties (the little balls are the handles).

The properties of the handles when selected and normal can be manipulated.

## ◆ GetLineProperty()

virtual vtkProperty* vtkLineWidget::GetLineProperty | ( |  | ) |
| virtual

Get the line properties.

The properties of the line when selected and unselected can be manipulated.

## ◆ GetSelectedLineProperty()

virtual vtkProperty* vtkLineWidget::GetSelectedLineProperty | ( |  | ) |
| virtual

Get the line properties.

The properties of the line when selected and unselected can be manipulated.

## ◆ ProcessEvents()

static void vtkLineWidget::ProcessEvents | ( | vtkObject * | object,
|  | unsigned long | event,
|  | void * | clientdata,
|  | void * | calldata
| ) |  |
| staticprotected

## ◆ OnLeftButtonDown()

void vtkLineWidget::OnLeftButtonDown | ( |  | ) |
| protected

## ◆ OnLeftButtonUp()

void vtkLineWidget::OnLeftButtonUp | ( |  | ) |
| protected

## ◆ OnMiddleButtonDown()

void vtkLineWidget::OnMiddleButtonDown | ( |  | ) |
| protected

## ◆ OnMiddleButtonUp()

void vtkLineWidget::OnMiddleButtonUp | ( |  | ) |
| protected

## ◆ OnRightButtonDown()

void vtkLineWidget::OnRightButtonDown | ( |  | ) |
| protected

## ◆ OnRightButtonUp()

void vtkLineWidget::OnRightButtonUp | ( |  | ) |
| protected

## ◆ OnMouseMove()

virtual void vtkLineWidget::OnMouseMove | ( |  | ) |
| protectedvirtual

## ◆ HighlightLine()

void vtkLineWidget::HighlightLine | ( | int | highlight | ) |
| protected

## ◆ BuildRepresentation()

void vtkLineWidget::BuildRepresentation | ( |  | ) |
| protected

## ◆ SizeHandles()

void vtkLineWidget::SizeHandles | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from vtk3DWidget.

## ◆ HandlesOn()

void vtkLineWidget::HandlesOn | ( | double | length | ) |
| protected

## ◆ HandlesOff()

void vtkLineWidget::HandlesOff | ( |  | ) |
| protected

## ◆ HighlightHandle()

int vtkLineWidget::HighlightHandle | ( | vtkProp * | prop | ) |
| protected

## ◆ HighlightHandles()

void vtkLineWidget::HighlightHandles | ( | int | highlight | ) |
| protected

## ◆ SetLinePosition()

void vtkLineWidget::SetLinePosition | ( | double | x[3] | ) |
| protected

## ◆ RegisterPickers()

void vtkLineWidget::RegisterPickers | ( |  | ) |
| overrideprotectedvirtual

Register internal Pickers in the Picking Manager.

Must be reimplemented by concrete widgets to register their pickers.

Reimplemented from vtkInteractorObserver.

## ◆ Scale()

void vtkLineWidget::Scale | ( | double * | p1,
|  | double * | p2,
|  | int | X,
|  | int | Y
| ) |  |
| protected

## ◆ ClampPosition()

void vtkLineWidget::ClampPosition | ( | double | x[3] | ) |
| protected

## ◆ InBounds()

int vtkLineWidget::InBounds | ( | double | x[3] | ) |
| protected

## ◆ CreateDefaultProperties()

void vtkLineWidget::CreateDefaultProperties | ( |  | ) |
| protected

## ◆ GenerateLine()

void vtkLineWidget::GenerateLine | ( |  | ) |
| protected

## ◆ EnablePointWidget()

void vtkLineWidget::EnablePointWidget | ( |  | ) |
| protected

## ◆ DisablePointWidget()

void vtkLineWidget::DisablePointWidget | ( |  | ) |
| protected

## ◆ ForwardEvent()

int vtkLineWidget::ForwardEvent | ( | unsigned long | event | ) |
| protected

## Friends And Related Function Documentation

## ◆ vtkPWCallback

friend class vtkPWCallback
| friend

Definition at line 198 of file vtkLineWidget.h.

## Member Data Documentation

## ◆ State

int vtkLineWidget::State
| protected

Definition at line 200 of file vtkLineWidget.h.

## ◆ Align

int vtkLineWidget::Align
| protected

Definition at line 224 of file vtkLineWidget.h.

## ◆ LineActor

vtkActor* vtkLineWidget::LineActor
| protected

Definition at line 235 of file vtkLineWidget.h.

## ◆ LineMapper

vtkPolyDataMapper* vtkLineWidget::LineMapper
| protected

Definition at line 236 of file vtkLineWidget.h.

## ◆ LineSource

vtkLineSource* vtkLineWidget::LineSource
| protected

Definition at line 237 of file vtkLineWidget.h.

## ◆ Handle

vtkActor** vtkLineWidget::Handle
| protected

Definition at line 241 of file vtkLineWidget.h.

## ◆ HandleMapper

vtkPolyDataMapper** vtkLineWidget::HandleMapper
| protected

Definition at line 242 of file vtkLineWidget.h.

## ◆ HandleGeometry

vtkSphereSource** vtkLineWidget::HandleGeometry
| protected

Definition at line 243 of file vtkLineWidget.h.

## ◆ HandlePicker

vtkCellPicker* vtkLineWidget::HandlePicker
| protected

Definition at line 253 of file vtkLineWidget.h.

## ◆ LinePicker

vtkCellPicker* vtkLineWidget::LinePicker
| protected

Definition at line 254 of file vtkLineWidget.h.

## ◆ CurrentHandle

vtkActor* vtkLineWidget::CurrentHandle
| protected

Definition at line 255 of file vtkLineWidget.h.

## ◆ LastPosition

double vtkLineWidget::LastPosition[3]
| protected

Definition at line 256 of file vtkLineWidget.h.

## ◆ ClampToBounds

vtkTypeBool vtkLineWidget::ClampToBounds
| protected

Definition at line 266 of file vtkLineWidget.h.

## ◆ HandleProperty

vtkProperty* vtkLineWidget::HandleProperty
| protected

Definition at line 272 of file vtkLineWidget.h.

## ◆ SelectedHandleProperty

vtkProperty* vtkLineWidget::SelectedHandleProperty
| protected

Definition at line 273 of file vtkLineWidget.h.

## ◆ LineProperty

vtkProperty* vtkLineWidget::LineProperty
| protected

Definition at line 274 of file vtkLineWidget.h.

## ◆ SelectedLineProperty

vtkProperty* vtkLineWidget::SelectedLineProperty
| protected

Definition at line 275 of file vtkLineWidget.h.

## ◆ PointWidget

vtkPointWidget* vtkLineWidget::PointWidget
| protected

Definition at line 281 of file vtkLineWidget.h.

## ◆ PointWidget1

vtkPointWidget* vtkLineWidget::PointWidget1
| protected

Definition at line 282 of file vtkLineWidget.h.

## ◆ PointWidget2

vtkPointWidget* vtkLineWidget::PointWidget2
| protected

Definition at line 283 of file vtkLineWidget.h.

## ◆ PWCallback

vtkPWCallback* vtkLineWidget::PWCallback
| protected

Definition at line 284 of file vtkLineWidget.h.

## ◆ PW1Callback

vtkPW1Callback* vtkLineWidget::PW1Callback
| protected

Definition at line 285 of file vtkLineWidget.h.

## ◆ PW2Callback

vtkPW2Callback* vtkLineWidget::PW2Callback
| protected

Definition at line 286 of file vtkLineWidget.h.

## ◆ CurrentPointWidget

vtkPointWidget* vtkLineWidget::CurrentPointWidget
| protected

Definition at line 287 of file vtkLineWidget.h.

The documentation for this class was generated from the following file:

- Interaction/Widgets/vtkLineWidget.h